import java.io.*;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.text.DecimalFormat;
import java.lang.*;

public class Evaluator extends JFrame implements ActionListener, ItemListener {
    Tester tester;
    final int elementzahl = 256 * 65536;
    static boolean geschwaetzig = true;
    static boolean byteformat = true;
    static byte testart = 1;
    static boolean normalertest = true;
    static int fortschrittzahl = 0;
    static int bitbreite = 0;
    static int bitzahl = 0;
    public static int c = 0;
    public static int letzterwert = 0;
    boolean zuwenigdaten = false;
    boolean abbruch = false;
    boolean skip = false;
    boolean dateigewaehlt = false;
    int letzteselement = -1;
    FileInputStream datei;
    DataInputStream bitdatei;
    String progname = new String("AIS 31 (V1) Reference Implementation - v1.0 ");
    String dateiname = new String("");
    File logfile;
    FileWriter logwriter;
    BufferedWriter logbuffer;
    PrintWriter log;
    private JRadioButton[] rb = new JRadioButton[9];
    private JLabel configlabel1 = new JLabel("Default Settings:");
    private JLabel vorgangslabel4 = new JLabel("");
    private JLabel configtest = new JLabel("TRNG Class:");
    private JLabel configausgabe = new JLabel("Output:");
    private JLabel configformat = new JLabel("Data Format:");
    private JLabel vorgangsname = new JLabel("Progress:");
    private JLabel configtestart = new JLabel("Test Type:");
    private JLabel zahlenbreite = new JLabel("Internal Random Numbers:");
    public JTextField dateieingabe = new JTextField("Enter file name in this style \"C:\\TestData\\File.dat\"", 40);
    public JTextField bitbreiteeingabe = new JTextField("Width in Bits", 7);
    private JProgressBar fortschritt = new JProgressBar(0, 300);
    private JButton dateisuchen = new JButton("Search File");
    private JButton hilfe = new JButton("Show Help");
    private JButton start5 = new JButton("S  T  A  R  T");
    private JScrollPane textpanel7;
    private JButton vorgangabbruch = new JButton("Cancel");
    private JTextArea textbox = new JTextArea(5, 50);
    boolean logfileenabled = true;


    public Evaluator() {
        super("AIS 31 (V1) Reference Implementation of the static tests - v1.0 [No Job]");
        setBounds(100, 100, 700, 550);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        try {
            logfile = new File("AIS 31.log");
            logwriter = new FileWriter(logfile);
            logbuffer = new BufferedWriter(logwriter);
            log = new PrintWriter(logbuffer);
        } catch (IOException e) {
            logfileenabled = false;
            kommentar("Failed to create AIS 31.log: " + e.toString(), true, 0);
        }
        JPanel hauptpanel = new JPanel();
        JPanel dateipanel2 = new JPanel();
        JPanel configpanel3 = new JPanel();
        JPanel vorgangspanel6 = new JPanel();
        rb[0] = new JRadioButton("P1: T1 - T5", true);
        rb[0].setToolTipText("Choose TNRG class P1, Test T1 - T5");
        rb[1] = new JRadioButton("P2 - specific", false);
        rb[1].setToolTipText("Choose TNRG class P2 (specific tests)");
        rb[2] = new JRadioButton("Normal", false);
        rb[2].setToolTipText("Choose output without details (test data, debug info, etc...)");
        rb[3] = new JRadioButton("Detailed", true);
        rb[3].setToolTipText("Choose output with details (test data, debug info, etc...)");
        rb[4] = new JRadioButton("1Byte = 1RNDBit", true);
        rb[4].setToolTipText("Exactly 1 random bit in 1 file byte");
        rb[5] = new JRadioButton("1Byte = 8RNDBit", false);
        rb[5].setToolTipText("Exactly 8 random bits in 1 file byte, older is most significant");
        rb[6] = new JRadioButton("Normal Test", true);
        rb[6].setToolTipText("TNRG undergoes normal test, no repeat test");
        rb[7] = new JRadioButton("Repetition", false);
        rb[7].setToolTipText("TNRG undergoes repeat test, since 1st test failed");
        rb[8] = new JRadioButton("P1: T0", false);
        rb[8].setToolTipText("Choose TNRG class P1, Test T0");
        fortschritt.setStringPainted(true);
        vorgangabbruch.setBackground(Color.red);
        vorgangabbruch
                .setToolTipText("During the time-consuming test suite (P0/T1-T5), this can be used to abort the test");
        start5.setToolTipText("Click here after entering data to start the test");
        dateisuchen.addActionListener(this);
        dateisuchen.setEnabled(false);
        dateisuchen.setToolTipText(
                "Open the Windows file search dialog (NOT FULLY IMPLEMENTED YET, please enter file names manually)");
        start5.setBackground(Color.green);
        start5.addActionListener(this);
        vorgangabbruch.addActionListener(this);
        hilfe.addActionListener(this);
        hilfe.setToolTipText("Show help text/instructions in the log window");
        hilfe.setBackground(Color.yellow);
        for (int i = 0; i < rb.length; i++) {
            rb[i].addItemListener(this);
        }
        GridBagLayout gblhaupt = new GridBagLayout();
        GridBagLayout gbl2 = new GridBagLayout();
        GridBagLayout gbl6 = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        dateipanel2.setLayout(gbl2);
        configpanel3.setLayout(new GridLayout(3, 5));
        vorgangspanel6.setLayout(gbl6);
        hauptpanel.setLayout(gblhaupt);
        buildConstraints(gbc, 0, 0, 1, 1, 1000, 100);
        gbl2.setConstraints(dateieingabe, gbc);
        dateieingabe.setToolTipText(
                "Enter the file name in the style \"<Drive>:\\<Path>\\<filename>.<extension>\" (Without quotes)");
        dateipanel2.add(dateieingabe);
        buildConstraints(gbc, 1, 0, 2, 1, 10, 100);
        gbl2.setConstraints(dateisuchen, gbc);
        configpanel3.add(rb[8]);
        configpanel3.add(configausgabe);
        configpanel3.add(configformat);
        configpanel3.add(configtestart);
        configpanel3.add(zahlenbreite);
        configpanel3.add(rb[0]);
        configpanel3.add(rb[2]);
        configpanel3.add(rb[4]);
        configpanel3.add(rb[6]);
        bitbreiteeingabe.setToolTipText("Width of internal random numbers in bits");
        configpanel3.add(bitbreiteeingabe);
        configpanel3.add(rb[1]);
        configpanel3.add(rb[3]);
        configpanel3.add(rb[5]);
        configpanel3.add(rb[7]);
        configpanel3.add(hilfe);
        buildConstraints(gbc, 0, 0, 1, 1, 10, 100);
        gbl6.setConstraints(vorgangsname, gbc);
        vorgangspanel6.add(vorgangsname);
        buildConstraints(gbc, 1, 0, 2, 1, 70, 100);
        gbl6.setConstraints(fortschritt, gbc);
        vorgangspanel6.add(fortschritt);
        buildConstraints(gbc, 3, 0, 1, 1, 10, 100);
        fortschritt.setToolTipText("During testing, this shows graphically how much % has been tested");
        textbox.setToolTipText("All program messages are written here chronologically with time.");
        gbl6.setConstraints(vorgangabbruch, gbc);
        vorgangspanel6.add(vorgangabbruch);
        textpanel7 = new JScrollPane(textbox);
        textbox.append(progname + "\nProgram started on " + systemdatum() + " at " + systemzeit()
                + " o'clock\n\nIF THERE ARE PROBLEMS, FOLLOW THESE THREE STEPS:\n     1) Hold mouse button over the object in question, help will appear\n     2) If problem not resolved, press Help button\n     3) If necessary: Technical inquiries to certification@bsi.bund.de");
        ButtonGroup rbgrpsicherheit = new ButtonGroup();
        ButtonGroup rbgrpausgabe = new ButtonGroup();
        ButtonGroup rbgrpformat = new ButtonGroup();
        ButtonGroup rbgrpwiederholung = new ButtonGroup();
        rbgrpsicherheit.add(rb[0]);
        rbgrpsicherheit.add(rb[1]);
        rbgrpsicherheit.add(rb[8]);
        rbgrpausgabe.add(rb[2]);
        rbgrpausgabe.add(rb[3]);
        rbgrpformat.add(rb[4]);
        rbgrpformat.add(rb[5]);
        rbgrpwiederholung.add(rb[6]);
        rbgrpwiederholung.add(rb[7]);
        buildConstraints(gbc, 0, 0, 1, 1, 100, 5);
        gblhaupt.setConstraints(configlabel1, gbc);
        hauptpanel.add(configlabel1);
        buildConstraints(gbc, 0, 1, 1, 1, 100, 5);
        gblhaupt.setConstraints(dateipanel2, gbc);
        hauptpanel.add(dateipanel2);
        buildConstraints(gbc, 0, 2, 1, 1, 100, 20);
        gblhaupt.setConstraints(configpanel3, gbc);
        hauptpanel.add(configpanel3);
        buildConstraints(gbc, 0, 3, 1, 1, 100, 5);
        gblhaupt.setConstraints(vorgangslabel4, gbc);
        hauptpanel.add(vorgangslabel4);
        buildConstraints(gbc, 0, 4, 1, 1, 100, 200);
        gblhaupt.setConstraints(start5, gbc);
        hauptpanel.add(start5);
        buildConstraints(gbc, 0, 5, 1, 1, 100, 15);
        gblhaupt.setConstraints(vorgangspanel6, gbc);
        hauptpanel.add(vorgangspanel6);
        buildConstraints(gbc, 0, 6, 1, 1, 100, 3000);
        gblhaupt.setConstraints(textpanel7, gbc);
        hauptpanel.add(textpanel7);
        setContentPane(hauptpanel);
        elementeAnpassen(0);
        fortschritt.setValue(fortschrittzahl);
        textbox.setEditable(false);
        show();
    }

    public void setzefortschritt(int schritt) {
        fortschritt.setValue(schritt);
    }

    public void actionPerformed(ActionEvent evt) {
        Object src = evt.getSource();
        if (src instanceof JButton) {
            if (src == dateisuchen) {
                JFileChooser dateidialog = new JFileChooser();
                dateidialog.setDialogTitle("Search File");
                if (dateidialog.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
                    dateieingabe.setText(dateidialog.getSelectedFile().getPath());
                }
            }
            if (src == start5) {
                kommentar("\n\nTEST STARTED.", true, 0);
                tester = new Tester(this);
                tester.start();
            }
            if (src == vorgangabbruch) {
                skip = true;
                abbruch = true;
            }
            if (src == hilfe) {
                kommentar("Help displayed - Log will resume afterwards.", true, 0);
                textbox.append("\n\n\nHELP from " + progname +
                        "\n\nThis program performs the statistical tests specified in the mathematical-technical annex to AIS 31. \nThe help texts are intended to facilitate the use of the program. \nFor understanding the correlations, reference is made to the mathematical-technical \nannex to AIS 31.\n"
                        +
                        "\nInstructions:\n" +
                        "   1) Enter the random number file with full path.\n" +
                        "   2) Select one entry each from the columns \"Tests\", \"Output\", \"Data Format\", and \"Test Type\".\n"
                        +
                        "   3) Specify the width of the internal random numbers in bits.\n" +
                        "   4) Press the Start button. Depending on your computer, the program may take several minutes. The progress bar shows the progress.\n"
                        +
                        "\nTest Suites:\n" +
                        "   P1: T0: See AIS 31, P1.i.(i) and F. Statistical Tests, Test T0\n" +
                        "   P1: T1-T5: See AIS 31, P1.i.(ii-ii.c) and F. Statistical Tests, Tests T1-T5\n" +
                        "   P2 - specific: P2 Specific Tests, See AIS 31, P2.i(vii.a-vii.e) and F. Statistical Tests, Tests T6-T8; (vii.a) ~ T6a, (vii.b) ~ T6b, (vii.c) ~ T7a, (vii.d) ~ T7b, (vii.e) ~ T8\n"
                        +
                        "\nInput / File Format:\n" +
                        "   1Byte=1RNDBit: Each byte of the input file corresponds to one random bit.\n" +
                        "   1Byte=8RNDBit: Each byte of the input file corresponds to 8 random bits,\n" +
                        "   with the most significant bit interpreted as the oldest.\n\n" +
                        "Test Type:\n" +
                        "   Normal = First execution of the respective test.\n" +
                        "   Repetition: Second execution of the respective test.\n\n" +
                        "Internal Random Numbers:\n" +
                        "   Width of the internal random numbers generated by the random number generator\n" +
                        "   in bits (see AIS 31, B.1 Definitions)\n\n" +
                        "Buttons:\n" +
                        "   Start Button (Green): Start the tests after selecting all settings.\n" +
                        "   Help Button (Yellow): Writes the complete help text into the text window.\n" +
                        "\nThe random numbers of the input file that are not needed to perform a test suite \n(T0, T1-T5, or P2-specific tests) will be written to a new file. The file name is derived from the input file by appending \n\"_rest\". After completing the test suite, this file will be entered into the input line by default.\n\n\n");

                kommentar("Help finished - Log will resume.", true, 0);
            }
        }
    }

    static String systemzeit() {
        String zahlenformat = new String("00");
        DecimalFormat df = new DecimalFormat(zahlenformat);
        GregorianCalendar cal = new GregorianCalendar();
        String zeit = new String(df.format(cal.get(Calendar.HOUR_OF_DAY)) + ":" + df.format(cal.get(Calendar.MINUTE))
                + ":" + df.format(cal.get(Calendar.SECOND)));
        return zeit;
    }

    static String systemdatum() {
        GregorianCalendar cal = new GregorianCalendar();
        String zahlenformat = new String("00");
        DecimalFormat df = new DecimalFormat(zahlenformat);
        String datum = new String(df.format(cal.get(Calendar.DAY_OF_MONTH)) + "."
                + df.format((cal.get(Calendar.MONTH) + 1)) + "." + df.format(cal.get(Calendar.YEAR)));
        return datum;
    }

    public void itemStateChanged(ItemEvent evt) {
        GregorianCalendar cal = new GregorianCalendar();
        Object src = evt.getSource();
        int srcnum = 0;
        for (int i = 0; i < 8; i++) {
            if (src == rb[i]) {
                srcnum = i;
            }
        }
        switch (srcnum) {
            case 8:
            case 0:
            case 1:
                if (rb[0].isSelected()) {
                    testart = 1;
                }
                if (rb[1].isSelected()) {
                    testart = 2;
                }
                if (rb[8].isSelected()) {
                    testart = 0;
                }
                break;
            case 2:
                geschwaetzig = !(rb[2].isSelected());
                if (geschwaetzig) {
                } else {
                }
                break;
            case 4:
                byteformat = (rb[4].isSelected());
                if (byteformat) {
                } else {
                }
                break;
            case 6:
                normalertest = (rb[6].isSelected());
                if (normalertest) {
                } else {
                }
                break;
        }
    }

    public void elementeAnpassen(int status) {
        switch (status) {
            case 0:
                setTitle(progname + " - [No Job]");
                for (int i = 0; i < rb.length; i++) {
                    rb[i].setEnabled(true);
                }
                configtest.setEnabled(true);
                configtestart.setEnabled(true);
                configlabel1.setEnabled(true);
                configausgabe.setEnabled(true);
                configformat.setEnabled(true);
                vorgangsname.setEnabled(false);
                dateieingabe.setEnabled(true);
                fortschritt.setEnabled(false);
                start5.setEnabled(true);
                vorgangabbruch.setEnabled(false);
                textbox.setEnabled(true);
                zahlenbreite.setEnabled(true);
                bitbreiteeingabe.setEnabled(true);
                hilfe.setEnabled(true);
                break;
            case 1:
                setTitle(progname + " - [Read File]");
                for (int i = 0; i < rb.length; i++) {
                    rb[i].setEnabled(false);
                }
                configtest.setEnabled(false);
                configausgabe.setEnabled(false);
                configtestart.setEnabled(false);
                configlabel1.setEnabled(false);
                configformat.setEnabled(false);
                vorgangsname.setEnabled(true);
                dateieingabe.setEnabled(false);
                fortschritt.setEnabled(true);
                dateisuchen.setEnabled(false);
                start5.setEnabled(false);
                vorgangabbruch.setEnabled(true);
                textbox.setEnabled(true);
                bitbreiteeingabe.setEnabled(false);
                zahlenbreite.setEnabled(false);
                hilfe.setEnabled(false);
                break;
            case 2:
                setTitle(progname + " - [Check in Progress]");
                for (int i = 0; i < rb.length; i++) {
                    rb[i].setEnabled(false);
                }
                configtest.setEnabled(false);
                configausgabe.setEnabled(false);
                configformat.setEnabled(false);
                configtestart.setEnabled(false);
                configlabel1.setEnabled(false);
                vorgangsname.setEnabled(true);
                dateieingabe.setEnabled(false);
                fortschritt.setEnabled(true);
                dateisuchen.setEnabled(false);
                start5.setEnabled(false);
                vorgangabbruch.setEnabled(true);
                textbox.setEnabled(true);
                zahlenbreite.setEnabled(false);
                bitbreiteeingabe.setEnabled(false);
                hilfe.setEnabled(false);
                break;
        }
    }

    public void kommentar(String text, boolean wichtig, int ebene) {
        if ((wichtig) | (geschwaetzig)) {
            textbox.append("\n[" + systemzeit() + "] ");
            if (ebene > 0) {
                for (int i = 0; i < ebene; i++) {
                    textbox.append("  ");
                }
            }
            textbox.append(text);
            textbox.setCaretPosition(textbox.getText().length());
            if (logfileenabled) {
                log.print("[" + systemzeit() + "] ");
                if (ebene > 0) {
                    for (int i = 0; i < ebene; i++) {
                        log.print("  ");
                    }
                }
                log.println(text);
            }
        }
    }

    void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
        gbc.gridx = gx;
        gbc.gridy = gy;
        gbc.gridwidth = gw;
        gbc.gridheight = gh;
        gbc.weightx = wx;
        gbc.weighty = wy;
        gbc.fill = GridBagConstraints.BOTH;
    }

    static void look() {
        try {
            UIManager.setLookAndFeel(
                    UIManager.getCrossPlatformLookAndFeelClassName());
        } catch (Exception e1) {
        }
    }

    public static void main(String[] arguments) {
        try {
            UIManager.setLookAndFeel(
                    UIManager.getCrossPlatformLookAndFeelClassName());
        } catch (Exception e1) {
        }
        Evaluator evaluator = new Evaluator();
    }

}

class Tester extends Thread {

    Evaluator evaluator;
    final int elementzahl = 256 * 65536;
    public byte[] BitFeldA = new byte[256 * 65536];
    public byte[] BitFeldB = new byte[20000];
    static boolean geschwaetzig;
    static boolean byteformat;
    static byte testart;
    static boolean normalertest;
    static int fortschrittzahlt;
    static int bitbreite;
    static int bitzahl;
    static int c;
    int letzterwert;
    boolean zuwenigdaten = false;
    boolean abbruch = false;
    boolean skip = false;
    boolean dateigewaehlt;
    int letzteselement;
    FileInputStream datei;
    DataInputStream bitdatei;
    String progname;

    Tester(Evaluator eva) {
        setPriority(NORM_PRIORITY);
        evaluator = eva;
        geschwaetzig = evaluator.geschwaetzig;
        byteformat = evaluator.byteformat;
        testart = evaluator.testart;
        normalertest = evaluator.normalertest;
        bitbreite = evaluator.bitbreite;
        bitzahl = evaluator.bitzahl;
        c = evaluator.c;
        letzterwert = evaluator.letzterwert;
        dateigewaehlt = evaluator.dateigewaehlt;
        letzteselement = evaluator.letzteselement;
        progname = evaluator.progname;

    }

    public boolean einlesen(byte[] BitFeldA) {

        String dateiname = evaluator.dateieingabe.getText();
        boolean eof = false;
        int anzahl = 0;
        boolean fehler = false;
        if (testart == 0) {
            c = teilenaufrunden(48, bitbreite);
            bitzahl = bitbreite * c * 65536;
        }
        if (testart == 1) {
            bitzahl = teilenaufrunden(257, (bitbreite + 1))
                    * ((teilenaufrunden(20000, bitbreite)) * bitbreite + (bitbreite * 20000));
        }
        if (testart == 2) {
            bitzahl = 7200000;
        }
        try {
            datei = new FileInputStream(dateiname);
            if (!byteformat) {
                int[] tempfeld = new int[teilenaufrunden(bitzahl, 8) + 1];
                bitdatei = new DataInputStream(datei);
                evaluator.kommentar("Copying BitStream file into RAM ...", false, 2);
                while ((!eof) && (anzahl < (teilenaufrunden(bitzahl, 8)))) {
                    try {
                        tempfeld[anzahl] = bitdatei.readUnsignedByte();
                    } catch (EOFException e2) {
                        eof = true;
                        evaluator.kommentar("File error: " + e2.toString(), true, 2);
                    }
                    anzahl++;
                }
                anzahl = anzahl * 8;
                for (int i = 0; i < BitFeldA.length; i++) {
                    BitFeldA[i] = 0;
                }
                evaluator.kommentar("Converting file data into ByteStream ...", false, 2);
                for (int i = 0; i < (teilenaufrunden(anzahl, 8)); i++) {
                    if (tempfeld[i] > 127) {
                        BitFeldA[(i * 8) + 0] = 1;
                        tempfeld[i] = tempfeld[i] - 128;
                    }
                    if (tempfeld[i] > 63) {
                        BitFeldA[(i * 8) + 1] = 1;
                        tempfeld[i] = tempfeld[i] - 64;
                    }
                    if (tempfeld[i] > 31) {
                        BitFeldA[(i * 8) + 2] = 1;
                        tempfeld[i] = tempfeld[i] - 32;
                    }
                    if (tempfeld[i] > 15) {
                        BitFeldA[(i * 8) + 3] = 1;
                        tempfeld[i] = tempfeld[i] - 16;
                    }
                    if (tempfeld[i] > 7) {
                        BitFeldA[(i * 8) + 4] = 1;
                        tempfeld[i] = tempfeld[i] - 8;
                    }
                    if (tempfeld[i] > 3) {
                        BitFeldA[(i * 8) + 5] = 1;
                        tempfeld[i] = tempfeld[i] - 4;
                    }
                    if (tempfeld[i] > 1) {
                        BitFeldA[(i * 8) + 6] = 1;
                        tempfeld[i] = tempfeld[i] - 2;
                    }
                    if (tempfeld[i] > 0) {
                        BitFeldA[(i * 8) + 7] = 1;
                    }
                }
            } else {
                evaluator.kommentar("Copying ByteStream into RAM ...", false, 2);
                anzahl = datei.read(BitFeldA, 0, bitzahl);
            }
        } catch (IOException e) {
            if (!dateigewaehlt) {
                evaluator.kommentar("File error: No file selected!", true, 2);
                return false;
            } else {
                evaluator.kommentar("File error: " + e.toString(), true, 2);
                return false;
            }
        }
        try {
            int filepos = 0;
            evaluator.setzefortschritt(21);
            evaluator.kommentar("Writing remaining file: " + dateiname + "_rest", true, 2);
            FileInputStream datei = new FileInputStream(dateiname);
            FileOutputStream datei2 = new FileOutputStream(dateiname + "_rest");
            if (byteformat) {
                eof = false;
                while (!eof) {
                    filepos++;
                    int elementtemp;
                    elementtemp = datei.read();
                    if (elementtemp == -1) {
                        eof = true;
                    } else {
                        if (filepos > teilenaufrunden(bitzahl, 8)) {
                            datei2.write(elementtemp);
                        }
                    }
                }
            } else {
                eof = false;
                while (!eof) {
                    filepos++;
                    int elementtemp;
                    elementtemp = datei.read();
                    if (elementtemp == -1) {
                        eof = true;
                    } else {
                        if (filepos > (bitzahl / 8)) {
                            datei2.write(elementtemp);
                        }
                    }
                }
            }
            datei.close();
            datei2.close();
        } catch (IOException e) {
            evaluator.kommentar("File error: " + e.toString(), true, 2);
        }
        if (anzahl < bitzahl) {
            evaluator.kommentar(
                    "File error: File too small. Minimum size " + bitzahl + " bits. Size: " + anzahl + " bits.", true,
                    2);
            return false;
        }
        evaluator.kommentar(anzahl + " elements copied into RAM.", false, 2);
        if (byteformat) {
            evaluator.kommentar("Checking data ...", false, 2);
            for (int i = 0; i < bitzahl; i++) {
                if ((BitFeldA[i] != 1) & (BitFeldA[i] != 0)) {
                    evaluator.kommentar("Element No. " + (i) + " not equal to \"0\" or \"1\", because \"" + BitFeldA[i]
                            + "\" - Data verification failed.", true, 2);
                    return false;
                }
            }
        }
        return true;
    }

    void neuesfeldb(byte[] BitFeldA, byte[] BitFeldB, int durchlauf) {
        int grundelement = 0;

        if (durchlauf % (bitbreite + 1) == 0) {
            evaluator.kommentar("Testing in block.", false, 1);
            for (int i = 0; i < 20000; i++) {
                BitFeldB[i] = BitFeldA[i + letzteselement + 1];
            }
            letzteselement += teilenaufrunden(20000, bitbreite) * bitbreite;
        } else {
            grundelement = (durchlauf % (bitbreite + 1)) + letzteselement;
            for (int i = 0; i < 20000; i++) {
                BitFeldB[i] = BitFeldA[grundelement + (i * bitbreite)];
            }
            if (durchlauf % (bitbreite + 1) == bitbreite) {
                letzteselement += 20000 * bitbreite;
            }

        }
    }

    int teilenaufrunden(int a, int b) {
        if ((a % b) == 0) {
            return (int) (a / b);
        } else {
            return (((int) (a / b)) + 1);
        }
    }

    public void run() {
        if (test()) {
            if (evaluator.testart == 0 | evaluator.testart == 1) {
                evaluator.kommentar("Run successfully completed, remaining file selected for testing.", true, 0);
            } else {
                evaluator.kommentar("Run successfully completed.", true, 0);
            }
        } else {
            evaluator.kommentar(
                    "Tests were not (completely) performed OR DID NOT PASS.\nIn addition to user interruption, this could be due to:\n1) A test was not passed (correct file format chosen?)\n2) User error (e.g., Internal random number width not entered)\n3) File error (file too small, not present, etc.)\nPlease search the LOG to find the error!",
                    true, 0);
        }
        try {
            evaluator.logbuffer.flush();
        } catch (IOException e) {
            evaluator.kommentar("Flush to AIS 31.log failed: " + e.toString(), true, 0);
        }
    }

    boolean test() {
        evaluator.setzefortschritt(0);
        boolean fehler = false;
        String vergleich = new String("Width in bits");
        String vergleichnull = new String("");
        if (vergleich.equals(evaluator.bitbreiteeingabe.getText())
                || vergleichnull.equals(evaluator.bitbreiteeingabe.getText())) {
            evaluator.kommentar("Please enter the bit width of the internal random numbers!", true, 0);
            return false;
        }
        bitbreite = Integer.parseInt(evaluator.bitbreiteeingabe.getText());
        if ((bitbreite > 256) || (bitbreite < 1)) {
            evaluator.kommentar("Bit width of internal random numbers not in the allowed range [1;256]", true, 0);
            return false;
        }
        if (testart == 0) {
            evaluator.kommentar("TEST SUITE:\tP1/T0", true, 0);
        }
        if (testart == 1) {
            evaluator.kommentar("TEST SUITE:\tP1/T1-T5", true, 0);
        }
        if (testart == 2) {
            evaluator.kommentar("TEST SUITE:\tP2 (specific tests)", true, 0);
        }
        evaluator.kommentar("FILENAME:\t" + evaluator.dateieingabe.getText(), true, 0);
        if (geschwaetzig) {
            evaluator.kommentar("OUTPUT DETAILS:\tOn.", true, 0);
        } else {
            evaluator.kommentar("OUTPUT DETAILS:\tOff.", true, 0);
        }
        if (byteformat) {
            evaluator.kommentar("DATA FORMAT:\t1 file byte contains 1 random bit.", true, 0);
        } else {
            evaluator.kommentar("DATA FORMAT:\t1 file byte contains 8 random bits.", true, 0);
        }
        if (normalertest) {
            evaluator.kommentar("TEST TYPE:\tNormal test.", true, 0);
        } else {
            evaluator.kommentar("TEST TYPE:\tRepetition test.", true, 0);
        }
        evaluator.kommentar("RND BIT WIDTH:\t" + bitbreite + " bit.", true, 0);
        String[] testnamen = new String[12];
        testnamen[0] = "Start test T0 (Disjointness test); Criterion P1.i(i)";
        testnamen[1] = "Start test T1 (Monobit test); Criterion P1.i(ii)";
        testnamen[2] = "Start test T2 (Poker test); Criterion P1.i(ii)";
        testnamen[3] = "Start test T3 (Run test); Criterion P1.i(ii)";
        testnamen[4] = "Start test T4 (Long Run test); Criterion P1.i(ii)";
        testnamen[5] = "Start test T5 (Autocorrelation test); Criterion P1.i(ii)";
        evaluator.kommentar("File is being read.", true, 1);
        evaluator.elementeAnpassen(1);
        if (einlesen(BitFeldA)) {
            evaluator.kommentar("File has been read.", false, 1);
            evaluator.setzefortschritt(42);
        } else {
            evaluator.kommentar("Reading the file failed.", true, 1);
            evaluator.elementeAnpassen(0);
            evaluator.setzefortschritt(0);
            return false;
        }
        evaluator.elementeAnpassen(2);
        if (testart == 0) {
            evaluator.kommentar(testnamen[0], true, 1);
            if (test0(c, bitbreite)) {
                evaluator.kommentar("Test T0 passed.", false, 1);
                evaluator.setzefortschritt(300);
                evaluator.dateieingabe.setText(evaluator.dateieingabe.getText() + "_rest");
            } else {
                evaluator.kommentar("Test T0 (Disjointness test); Criterion P1.i(i) not passed.", true, 1);
                fehler = true;
            }
        }
        if (testart == 1) {
            for (int durchlauf = 0; durchlauf < 257; durchlauf++) {
                if (evaluator.abbruch) {
                    evaluator.kommentar("Aborted at user's request.", true, 0);
                    evaluator.elementeAnpassen(0);
                    evaluator.abbruch = false;
                    return false;
                }
                boolean durchlauffehler = false;
                evaluator.kommentar("Starting run " + (durchlauf + 1) + " of 257.", true, 1);
                neuesfeldb(BitFeldA, BitFeldB, durchlauf);
                evaluator.kommentar(testnamen[1], false, 2);
                if (test1()) {
                    evaluator.kommentar("Test T1 passed.", false, 2);
                } else {
                    evaluator.kommentar("Test T1 (Monobit test); Criterion P1.i(ii) not passed.", true, 2);
                    durchlauffehler = true;
                }
                evaluator.kommentar(testnamen[2], false, 2);
                if (test2()) {
                    evaluator.kommentar("Test T2 passed.", false, 2);
                } else {
                    evaluator.kommentar("Test T2 (Poker test); Criterion P1.i(ii) not passed.", true, 2);
                    durchlauffehler = true;
                }
                evaluator.kommentar(testnamen[3], false, 2);
                if (test3()) {
                    evaluator.kommentar("Test T3 passed.", false, 2);
                } else {
                    evaluator.kommentar("Test T3 (Run test); Criterion P1.i(ii) not passed.", true, 2);
                    durchlauffehler = true;
                }
                evaluator.kommentar(testnamen[4], false, 2);
                if (test4()) {
                    evaluator.kommentar("Test T4 passed.", false, 2);
                } else {
                    evaluator.kommentar("Test T4 (Long Run test); Criterion P1.i(ii) not passed.", true, 2);
                    durchlauffehler = true;
                }
                evaluator.kommentar(testnamen[5], false, 2);
                if (test5()) {
                    evaluator.kommentar("Test T5 passed.", false, 2);
                } else {
                    evaluator.kommentar("Test T5 (Autocorrelation test); Criterion P1.i(ii) not passed.", true, 2);
                    durchlauffehler = true;
                }
                if (durchlauffehler) {
                    evaluator.kommentar("Run " + (durchlauf + 1) + " not passed.", true, 1);
                    fehler = true;
                } else {
                    evaluator.kommentar("Run " + (durchlauf + 1) + " passed.", false, 1);
                }
                evaluator.setzefortschritt(durchlauf + 42);
            }
            evaluator.setzefortschritt(300);
            evaluator.dateieingabe.setText(evaluator.dateieingabe.getText() + "_rest");
        }
        if (testart == 2) {
            evaluator.kommentar("Test procedure T6a for verification of P2.i)(vii.a) started.", false, 1);
            if (test6a()) {
                evaluator.kommentar("Test procedure T6a passed.", false, 1);
            } else {
                evaluator.kommentar("Test procedure T6a for verification of P2.i)(vii.a) not passed.", true, 1);
                fehler = true;
            }
            if (zuwenigdaten) {
                evaluator.kommentar(
                        "Insufficient test data - test series aborted (program reads a maximum of 7200000 random bits).",
                        true, 1);
                return false;
            }
            evaluator.setzefortschritt(100);
            evaluator.kommentar("Test procedure T6b for verification of P2.i)(vii.b) started.", false, 1);
            if (test6b()) {
                evaluator.kommentar("Test procedure T6b passed.", false, 1);
            } else {
                evaluator.kommentar("Test procedure T6b for verification of P2.i)(vii.b) not passed.", true, 1);
                fehler = true;
            }
            if (zuwenigdaten) {
                evaluator.kommentar(
                        "Insufficient test data - test series aborted (program reads a maximum of 7200000 random bits).",
                        true, 1);
                return false;
            }
            evaluator.setzefortschritt(150);
            evaluator.kommentar("Test procedure T7a for verification of P2.i)(vii.c) started.", false, 1);
            if (test7a()) {
                evaluator.kommentar("Test procedure T7a passed.", false, 1);
            } else {
                evaluator.kommentar("Test procedure T7a for verification of P2.i)(vii.c) not passed.", true, 1);
                fehler = true;
            }
            if (zuwenigdaten) {
                evaluator.kommentar(
                        "Insufficient test data - test series aborted (program reads a maximum of 7200000 random bits).",
                        true, 1);
                return false;
            }
            evaluator.setzefortschritt(200);
            evaluator.kommentar("Test procedure T7b for verification of P2.i)(vii.d) started.", false, 1);
            if (test7b()) {
                evaluator.kommentar("Test procedure T7b passed.", false, 1);
            } else {
                evaluator.kommentar("Test procedure T7b for verification of P2.i)(vii.d) not passed.", true, 1);
                fehler = true;
            }
            if (zuwenigdaten) {
                evaluator.kommentar(
                        "Insufficient test data - test series aborted (program reads a maximum of 7200000 random bits).",
                        true, 1);
                return false;
            }
            evaluator.setzefortschritt(250);
            evaluator.kommentar("Test T8 for verification of P2.i)(vii.e) started.", false, 1);
            if (test8()) {
                evaluator.kommentar("Test T8 passed.", false, 1);
            } else {
                evaluator.kommentar("Test T8 for verification of P2.i)(vii.e) not passed.", true, 1);
                fehler = true;
            }
            evaluator.setzefortschritt(300);
        }
        evaluator.elementeAnpassen(0);
        return !fehler;
    }

    boolean test0(int c, int bitbreite) {
        int i, j, einsen;
        boolean ok;
        long u0 = (long) 0;
        long u1 = (long) 1;
        long[] WFeld = new long[65536];
        for (i = 0; i < 65536; i++) {
            WFeld[i] = u0;
            for (j = 0; j < 48; j++)
                WFeld[i] += (u1 << j) * BitFeldA[(c * bitbreite) * i + j];
        }
        Arrays.sort(WFeld);
        ok = true;
        for (i = 1; i < 65536; i++) {
            if (WFeld[i - 1] == WFeld[i]) {
                ok = false;
            }
        }
        return ok;
    }

    boolean test1() {
        int i, einsen, mg = 20000, ptest = 0;
        boolean ok;
        einsen = 0;
        for (i = 0; i < mg; i++) {
            einsen += BitFeldB[i];
        }
        if ((einsen > 9654) && (einsen < 10346))
            ok = true;
        else
            ok = false;
        evaluator.kommentar("Number of ones: " + einsen, false, 3);
        evaluator.kommentar("Admissible range: [9655; 10345]", false, 2);
        return ok;
    }

    boolean test2() {
        int i, j, index, ptest;
        int[] Hfg = new int[16];
        boolean ok;
        double testgroesse;

        for (i = 0; i < 16; i++)
            Hfg[i] = 0;
        for (i = 0; i < 5000; i++) {
            index = 0;
            for (j = 0; j < 4; j++)
                index += (1 << j) * BitFeldB[4 * i + j];
            Hfg[index]++;
        }
        testgroesse = 0.0;
        for (i = 0; i < 16; i++)
            testgroesse += Hfg[i] * Hfg[i];
        testgroesse = testgroesse * (16.0 / 5000.0) - 5000.0;
        if ((testgroesse > 1.03) && (testgroesse < 57.4))
            ok = true;
        else
            ok = false;
        if (geschwaetzig) {
            evaluator.kommentar("Test size = " + testgroesse, false, 3);
        }
        return ok;
    }

    boolean test3() {
        int i, j, run, ptest = 0;
        int[] Run0Feld = new int[7];
        int[] Run1Feld = new int[7];
        boolean ok;
        int UGrenze[] = { 0, 2267, 1079, 502, 223, 90, 90 };
        int OGrenze[] = { 0, 2733, 1421, 748, 402, 223, 223 };
        for (i = 0; i < 7; i++)
            Run0Feld[i] = Run1Feld[i] = 0;
        run = 1;
        for (i = 1; i < 20000; i++) {
            if (BitFeldB[i - 1] == BitFeldB[i])
                run++;
            else {
                if (run > 6)
                    run = 6;
                if (BitFeldB[i - 1] == 1)
                    Run1Feld[run]++;
                else
                    Run0Feld[run]++;
                run = 1;
            }
        }
        if (run > 6)
            run = 6;
        if (BitFeldB[i - 1] == 1)
            Run1Feld[run]++;
        else
            Run0Feld[run]++;
        ok = true;
        for (i = 1; i <= 6; i++) {
            if ((Run0Feld[i] >= UGrenze[i]) && (Run0Feld[i] <= OGrenze[i])) {
                evaluator.kommentar("0-Runs[" + i + "] = " + Run0Feld[i] + "; Admissible interval: [" + UGrenze[i]
                        + "; " + OGrenze[i] + "]", false, 3);
            } else {
                ok = false;
                evaluator.kommentar("ERROR: 0-Runs[" + i + "] = " + Run0Feld[i] + "; Admissible interval: ["
                        + UGrenze[i] + "; " + OGrenze[i] + "]", true, 3);
            }
            if ((Run1Feld[i] >= UGrenze[i]) && (Run1Feld[i] <= OGrenze[i])) {
                evaluator.kommentar("1-Runs[" + i + "] = " + Run1Feld[i] + "; Admissible interval: [" + UGrenze[i]
                        + "; " + OGrenze[i] + "]", false, 3);
            } else {
                ok = false;
                evaluator.kommentar("ERROR: 1-Runs[" + i + "] = " + Run1Feld[i] + "; Admissible interval: ["
                        + UGrenze[i] + "; " + OGrenze[i] + "]", true, 3);
            }
        }
        return ok;
    }

    boolean test4() {
        int i, run, ptest = 0;
        boolean ok;

        run = 1;
        ok = true;

        for (i = 1; i < 20000; i++) {
            if (BitFeldB[i - 1] == BitFeldB[i]) {
                run++;
                if (run >= 34) {
                    ok = false;
                    evaluator.kommentar(
                            "Long Run detected (Value: " + BitFeldB[i] + "). First bit position: " + (i - 33) + ".",
                            true, 2);
                }
            } else
                run = 1;
        }
        return ok;
    }

    boolean test5() {
        int i, j, k, tau, Z_tau, max, maxindex, ptest = 0;
        boolean ok;
        int[] ShiftFeld = new int[5000];
        int[] MaxKorrFeld = new int[5000];

        for (tau = 1; tau <= 5000; tau++) {
            Z_tau = 0;
            for (i = 0; i < 5000; i++)
                Z_tau += (BitFeldB[i] ^ BitFeldB[i + tau]);
            ShiftFeld[tau - 1] = Z_tau;
        }

        max = 0;

        for (tau = 0; tau < 5000; tau++) {
            if (Math.abs(ShiftFeld[tau] - 2500) > max) {
                max = Math.abs(ShiftFeld[tau] - 2500);
            }
        }

        j = 0;
        for (tau = 0; tau < 5000; tau++) {
            if (Math.abs(ShiftFeld[tau] - 2500) == max) {
                MaxKorrFeld[j] = tau;
                j++;
            }
        }

        evaluator.kommentar("Maximum Z_tau deviation from 2500: " + max, false, 3);
        evaluator.kommentar("Occurred for Shifts: ", false, 3);
        for (k = 0; k < j; k++) {
            evaluator.kommentar("Shift: " + (MaxKorrFeld[k] + 1), false, 4);
        }
        tau = MaxKorrFeld[0];
        Z_tau = 0;
        for (i = 10000; i < 15000; i++) {
            Z_tau += (BitFeldB[i] ^ BitFeldB[i + tau + 1]);
        }
        tau++;
        evaluator.kommentar("Re-run of autocorrelation test with Shift: " + tau + " on Bits 10,000 to 14,999", false,
                3);
        evaluator.kommentar("Z_" + tau + " = " + Z_tau, false, 3);
        if ((Z_tau > 2326) && (Z_tau < 2674))
            ok = true;
        else
            ok = false;
        return ok;
    }

    boolean test6a() {
        boolean ok;
        double[] prob = new double[1];
        double absdiff = 0.0;
        int groesse = 100000;
        int einsen = 0;
        for (int i = 0; i < groesse; i++)
            einsen += BitFeldA[i];
        prob[0] = (double) einsen / (double) groesse;
        absdiff = Math.abs(prob[0] - 0.5);
        if ((absdiff < 0.025))
            ok = true;
        else
            ok = false;
        letzterwert = groesse;
        evaluator.kommentar("|P(1) - 0.5| = " + absdiff, false, 2);
        evaluator.kommentar("Last Element: " + letzterwert, false, 2);
        return ok;
    }

    boolean test6b() {
        int groesse = 100000;
        int[] counter = { 0, 0 };
        int einsen[] = { 0, 0 };
        int voll[] = { 0, 0 };
        int i = 0;
        double[] prob = new double[2];
        double absdiff = 0.0;
        while ((voll[0] + voll[1] < 2) && ((letzterwert + 2 * i + 1) < bitzahl)) {
            if (voll[BitFeldA[letzterwert + 2 * i]] == 1)
                ;
            else {
                counter[BitFeldA[letzterwert + 2 * i]] += 1;
                if (counter[BitFeldA[letzterwert + 2 * i]] == groesse)
                    voll[BitFeldA[letzterwert + 2 * i]] = 1;
                einsen[BitFeldA[letzterwert + 2 * i]] += BitFeldA[letzterwert + 2 * i + 1];
            }
            i++;
        }
        letzterwert += 2 * i;
        if (voll[0] + voll[1] < 2) {
            evaluator.kommentar("Input file too small....Criterion P2.i)(vii.b) could not be verified.", true, 2);
            zuwenigdaten = true;
            return false;
        } else {

            for (i = 0; i < 2; i++)
                prob[i] = (double) einsen[i] / groesse;
            absdiff = Math.abs(prob[0] - prob[1]);
            evaluator.kommentar("p(01) = " + prob[0], false, 2);
            evaluator.kommentar("p(11) = " + prob[1], false, 2);
            evaluator.kommentar("|p_(01) - p_(11)| = " + absdiff, false, 2);
            evaluator.kommentar("Last Element: " + letzterwert, false, 2);
            if (absdiff < 0.02)
                return true;
            else
                return false;
        }
    }

    boolean test7a() {
        int groesse = 100000;
        int hilf;
        int[] voll = { 0, 0, 0, 0 };
        int[] counter = { 0, 0, 0, 0 };
        int[] einsen = { 0, 0, 0, 0 };
        int[] nullen = { 0, 0, 0, 0 };
        double sum = 0;
        int i = 0;
        while ((voll[0] + voll[1] + voll[2] + voll[3] < 4) && ((letzterwert + 3 * i) < bitzahl)) {
            hilf = 2 * BitFeldA[letzterwert + 3 * i + 1] + BitFeldA[letzterwert + 3 * i];
            if (voll[hilf] == 1)
                ;
            else {
                counter[hilf] += 1;
                if (counter[hilf] == groesse)
                    voll[hilf] = 1;
                einsen[hilf] += BitFeldA[letzterwert + 3 * i + 2];
            }
            i++;
        }
        letzterwert += 3 * i;
        if (voll[0] + voll[1] + voll[2] + voll[3] < 4) {
            evaluator.kommentar("Input file too small....Criterion P2.i)(vii.c) could not be verified", true, 2);
            zuwenigdaten = true;
            return false;
        } else {
            for (i = 0; i < 4; i++)
                nullen[i] = groesse - einsen[i];
            boolean ok = true;
            for (i = 0; i < 2; i++) {
                sum = ((double) ((nullen[2 * i] - nullen[2 * i + 1]) * (nullen[2 * i] - nullen[2 * i + 1]))
                        / (nullen[2 * i] + nullen[2 * i + 1])
                        + (double) ((einsen[2 * i] - einsen[2 * i + 1]) * (einsen[2 * i] - einsen[2 * i + 1]))
                                / (einsen[2 * i] + einsen[2 * i + 1]));
                if (sum > 15.13)
                    ok = false;
                evaluator.kommentar("Test size[" + i + "] = " + sum, false, 2);
            }
            evaluator.kommentar("Last Element: " + letzterwert, false, 2);
            return ok;
        }
    }

    boolean test7b() {
        boolean ok;
        int hilf;
        int[] voll = { 0, 0, 0, 0, 0, 0, 0, 0 };
        int[] counter = { 0, 0, 0, 0, 0, 0, 0, 0 };
        int[] einsen = { 0, 0, 0, 0, 0, 0, 0, 0 };
        int[] nullen = { 0, 0, 0, 0, 0, 0, 0, 0 };
        double sum = 0;
        int groesse = 100000;
        int i = 0;
        while ((voll[0] + voll[1] + voll[2] + voll[3] + voll[4] + voll[5] + voll[6] + voll[7] < 8)
                && ((letzterwert + 4 * i) < bitzahl)) {
            hilf = 4 * BitFeldA[letzterwert + 4 * i + 2] + 2 * BitFeldA[letzterwert + 4 * i + 1]
                    + BitFeldA[letzterwert + 4 * i];
            if (voll[hilf] == 1)
                ;
            else {
                counter[hilf] += 1;
                if (counter[hilf] == groesse)
                    voll[hilf] = 1;
                einsen[hilf] += BitFeldA[letzterwert + 4 * i + 3];
            }
            i++;
        }
        letzterwert += 4 * i;
        if (voll[0] + voll[1] + voll[2] + voll[3] + voll[4] + voll[5] + voll[6] + voll[7] < 8) {
            evaluator.kommentar("Input file too small...Criterion P2.i)(vii.d) could not be tested", true, 2);
            zuwenigdaten = true;
            ok = false;
        } else {
            for (i = 0; i < 8; i++)
                nullen[i] = groesse - einsen[i];
            ok = true;
            for (i = 0; i < 4; i++) {
                sum = (double) ((nullen[2 * i] - nullen[2 * i + 1]) * (nullen[2 * i] - nullen[2 * i + 1]))
                        / (nullen[2 * i] + nullen[2 * i + 1])
                        + (double) ((einsen[2 * i] - einsen[2 * i + 1]) * (einsen[2 * i] - einsen[2 * i + 1]))
                                / (einsen[2 * i] + einsen[2 * i + 1]);
                if (sum > 15.13)
                    ok = false;
                evaluator.kommentar("Test Size[" + i + "] = " + sum, false, 2);
            }
        }
        evaluator.kommentar("Last Element: " + letzterwert, false, 2);
        return ok;
    }

    boolean test8() {

        final int L = 8;
        final int Q = 2560;
        final int K = 256000;
        int hilf = 0;
        int counter = 0;
        int[] letzteposition = new int[256];
        for (int i = 0; i < 256; i++) {
            letzteposition[i] = -1;
        }
        int[] W = new int[Q + K];
        double TG;
        double[] G = new double[K + Q + 1];
        int abstand;

        G[1] = 0.0;
        for (int i = 1; i <= K + Q - 1; i++)
            G[i + 1] = G[i] + 1.0 / (i);
        for (int i = 1; i <= K + Q; i++)
            G[i] /= Math.log(2.0);
        for (int i = 0; i < Q; i++) {
            hilf = 0;
            for (int j = 0; j < 8; j++) {
                hilf += BitFeldA[letzterwert + 8 * i + j] << j;
            }
            letzteposition[hilf] = i;
        }
        TG = 0.0;
        for (int i = Q; i < K + Q; i++) {
            hilf = 0;
            for (int j = 0; j < 8; j++) {
                hilf += BitFeldA[letzterwert + 8 * i + j] << j;
            }
            abstand = i - letzteposition[hilf];
            letzteposition[hilf] = i;
            TG += G[abstand];
        }
        TG /= (double) K;
        evaluator.kommentar("Test Size = " + TG, false, 2);
        letzterwert += 8 * (2560 + 256000);
        evaluator.kommentar("Last Element: " + letzterwert, false, 2);
        if (TG > 7.976)
            return true;
        else
            return false;
    }

}
